/* Automatically generated nanopb header */
/* Generated by nanopb-0.4.5 */

#ifndef PB_VSCR_RATCHETSESSION_PB_H_INCLUDED
#define PB_VSCR_RATCHETSESSION_PB_H_INCLUDED
#include <pb.h>

#if PB_PROTO_HEADER_VERSION != 40
#error Regenerate this file with the current version of nanopb generator.
#endif

/* Struct definitions */
typedef struct _vscr_SessionPqcInfo { 
    pb_bytes_array_t *encapsulated_key1; 
    pb_bytes_array_t *encapsulated_key2; 
    pb_bytes_array_t *encapsulated_key3; 
    pb_bytes_array_t *decapsulated_keys_signature; 
} vscr_SessionPqcInfo;

typedef struct _vscr_ChainKey { 
    uint32_t index; 
    pb_byte_t key[32]; 
} vscr_ChainKey;

typedef struct _vscr_MessageKey { 
    uint32_t index; 
    pb_byte_t key[32]; 
} vscr_MessageKey;

typedef struct _vscr_SkippedMessageKey { 
    pb_byte_t public_key_id[8]; 
    pb_size_t message_keys_count;
    struct _vscr_MessageKey *message_keys; 
} vscr_SkippedMessageKey;

typedef struct _vscr_GroupSession { 
    uint32_t version; 
    uint32_t my_epoch; 
    vscr_ChainKey my_chain_key; 
    uint32_t messages_count[4]; 
    pb_byte_t session_id[32]; 
    pb_byte_t my_id[32]; 
    pb_size_t participants_count;
    struct _vscr_ParticipantData *participants; 
} vscr_GroupSession;

typedef struct _vscr_ParticipantEpoch { 
    uint32_t epoch; 
    bool is_empty; 
    bool has_chain_key;
    vscr_ChainKey chain_key; 
    pb_size_t message_keys_count;
    struct _vscr_MessageKey *message_keys; 
} vscr_ParticipantEpoch;

typedef struct _vscr_ReceiverChain { 
    pb_byte_t public_key_id[8]; 
    pb_byte_t public_key_first[32]; 
    pb_bytes_array_t *public_key_second; 
    vscr_ChainKey chain_key; 
} vscr_ReceiverChain;

typedef struct _vscr_SenderChain { 
    pb_byte_t private_key_first[32]; 
    pb_byte_t public_key_first[32]; 
    pb_bytes_array_t *private_key_second; 
    pb_bytes_array_t *public_key_second; 
    pb_bytes_array_t *encapsulated_key; 
    vscr_ChainKey chain_key; 
} vscr_SenderChain;

typedef struct _vscr_SkippedMessages { 
    pb_size_t keys_count;
    vscr_SkippedMessageKey keys[5]; 
} vscr_SkippedMessages;

typedef struct _vscr_ParticipantData { 
    pb_byte_t id[32]; 
    pb_byte_t pub_key[32]; 
    vscr_ParticipantEpoch epochs[5]; 
} vscr_ParticipantData;

typedef struct _vscr_Ratchet { 
    bool has_sender_chain;
    vscr_SenderChain sender_chain; 
    uint32_t prev_sender_chain_count; 
    bool has_receiver_chain;
    vscr_ReceiverChain receiver_chain; 
    pb_byte_t root_key[32]; 
    vscr_SkippedMessages skipped_messages; 
    bool enable_post_quantum; 
} vscr_Ratchet;

typedef struct _vscr_Session { 
    uint32_t version; 
    bool received_first_response; 
    bool is_initiator; 
    bool enable_post_quantum; 
    bool receiver_has_one_time_public_key; 
    bool has_sender_identity_key_id;
    pb_byte_t sender_identity_key_id[8]; 
    bool has_sender_ephemeral_key;
    pb_byte_t sender_ephemeral_key[32]; 
    bool has_receiver_identity_key_id;
    pb_byte_t receiver_identity_key_id[8]; 
    bool has_receiver_long_term_key_id;
    pb_byte_t receiver_long_term_key_id[8]; 
    bool has_receiver_one_time_key_id;
    pb_byte_t receiver_one_time_key_id[8]; 
    bool has_pqc_info;
    vscr_SessionPqcInfo pqc_info; 
    vscr_Ratchet ratchet; 
} vscr_Session;


#ifdef __cplusplus
extern "C" {
#endif

/* Initializer values for message structs */
#define vscr_ChainKey_init_default               {0, {0}}
#define vscr_MessageKey_init_default             {0, {0}}
#define vscr_SenderChain_init_default            {{0}, {0}, NULL, NULL, NULL, vscr_ChainKey_init_default}
#define vscr_ReceiverChain_init_default          {{0}, {0}, NULL, vscr_ChainKey_init_default}
#define vscr_SkippedMessageKey_init_default      {{0}, 0, NULL}
#define vscr_SkippedMessages_init_default        {0, {vscr_SkippedMessageKey_init_default, vscr_SkippedMessageKey_init_default, vscr_SkippedMessageKey_init_default, vscr_SkippedMessageKey_init_default, vscr_SkippedMessageKey_init_default}}
#define vscr_Ratchet_init_default                {false, vscr_SenderChain_init_default, 0, false, vscr_ReceiverChain_init_default, {0}, vscr_SkippedMessages_init_default, 0}
#define vscr_SessionPqcInfo_init_default         {NULL, NULL, NULL, NULL}
#define vscr_Session_init_default                {0, 0, 0, 0, 0, false, {0}, false, {0}, false, {0}, false, {0}, false, {0}, false, vscr_SessionPqcInfo_init_default, vscr_Ratchet_init_default}
#define vscr_ParticipantEpoch_init_default       {0, 0, false, vscr_ChainKey_init_default, 0, NULL}
#define vscr_ParticipantData_init_default        {{0}, {0}, {vscr_ParticipantEpoch_init_default, vscr_ParticipantEpoch_init_default, vscr_ParticipantEpoch_init_default, vscr_ParticipantEpoch_init_default, vscr_ParticipantEpoch_init_default}}
#define vscr_GroupSession_init_default           {0, 0, vscr_ChainKey_init_default, {0, 0, 0, 0}, {0}, {0}, 0, NULL}
#define vscr_ChainKey_init_zero                  {0, {0}}
#define vscr_MessageKey_init_zero                {0, {0}}
#define vscr_SenderChain_init_zero               {{0}, {0}, NULL, NULL, NULL, vscr_ChainKey_init_zero}
#define vscr_ReceiverChain_init_zero             {{0}, {0}, NULL, vscr_ChainKey_init_zero}
#define vscr_SkippedMessageKey_init_zero         {{0}, 0, NULL}
#define vscr_SkippedMessages_init_zero           {0, {vscr_SkippedMessageKey_init_zero, vscr_SkippedMessageKey_init_zero, vscr_SkippedMessageKey_init_zero, vscr_SkippedMessageKey_init_zero, vscr_SkippedMessageKey_init_zero}}
#define vscr_Ratchet_init_zero                   {false, vscr_SenderChain_init_zero, 0, false, vscr_ReceiverChain_init_zero, {0}, vscr_SkippedMessages_init_zero, 0}
#define vscr_SessionPqcInfo_init_zero            {NULL, NULL, NULL, NULL}
#define vscr_Session_init_zero                   {0, 0, 0, 0, 0, false, {0}, false, {0}, false, {0}, false, {0}, false, {0}, false, vscr_SessionPqcInfo_init_zero, vscr_Ratchet_init_zero}
#define vscr_ParticipantEpoch_init_zero          {0, 0, false, vscr_ChainKey_init_zero, 0, NULL}
#define vscr_ParticipantData_init_zero           {{0}, {0}, {vscr_ParticipantEpoch_init_zero, vscr_ParticipantEpoch_init_zero, vscr_ParticipantEpoch_init_zero, vscr_ParticipantEpoch_init_zero, vscr_ParticipantEpoch_init_zero}}
#define vscr_GroupSession_init_zero              {0, 0, vscr_ChainKey_init_zero, {0, 0, 0, 0}, {0}, {0}, 0, NULL}

/* Field tags (for use in manual encoding/decoding) */
#define vscr_SessionPqcInfo_encapsulated_key1_tag 1
#define vscr_SessionPqcInfo_encapsulated_key2_tag 2
#define vscr_SessionPqcInfo_encapsulated_key3_tag 3
#define vscr_SessionPqcInfo_decapsulated_keys_signature_tag 4
#define vscr_ChainKey_index_tag                  1
#define vscr_ChainKey_key_tag                    2
#define vscr_MessageKey_index_tag                1
#define vscr_MessageKey_key_tag                  2
#define vscr_SkippedMessageKey_public_key_id_tag 1
#define vscr_SkippedMessageKey_message_keys_tag  2
#define vscr_GroupSession_version_tag            1
#define vscr_GroupSession_my_epoch_tag           2
#define vscr_GroupSession_my_chain_key_tag       3
#define vscr_GroupSession_messages_count_tag     4
#define vscr_GroupSession_session_id_tag         5
#define vscr_GroupSession_my_id_tag              6
#define vscr_GroupSession_participants_tag       7
#define vscr_ParticipantEpoch_epoch_tag          1
#define vscr_ParticipantEpoch_is_empty_tag       2
#define vscr_ParticipantEpoch_chain_key_tag      3
#define vscr_ParticipantEpoch_message_keys_tag   4
#define vscr_ReceiverChain_public_key_id_tag     1
#define vscr_ReceiverChain_public_key_first_tag  2
#define vscr_ReceiverChain_public_key_second_tag 3
#define vscr_ReceiverChain_chain_key_tag         4
#define vscr_SenderChain_private_key_first_tag   1
#define vscr_SenderChain_public_key_first_tag    2
#define vscr_SenderChain_private_key_second_tag  3
#define vscr_SenderChain_public_key_second_tag   4
#define vscr_SenderChain_encapsulated_key_tag    5
#define vscr_SenderChain_chain_key_tag           6
#define vscr_SkippedMessages_keys_tag            1
#define vscr_ParticipantData_id_tag              1
#define vscr_ParticipantData_pub_key_tag         2
#define vscr_ParticipantData_epochs_tag          3
#define vscr_Ratchet_sender_chain_tag            1
#define vscr_Ratchet_prev_sender_chain_count_tag 2
#define vscr_Ratchet_receiver_chain_tag          3
#define vscr_Ratchet_root_key_tag                4
#define vscr_Ratchet_skipped_messages_tag        5
#define vscr_Ratchet_enable_post_quantum_tag     6
#define vscr_Session_version_tag                 1
#define vscr_Session_received_first_response_tag 2
#define vscr_Session_is_initiator_tag            3
#define vscr_Session_enable_post_quantum_tag     4
#define vscr_Session_receiver_has_one_time_public_key_tag 5
#define vscr_Session_sender_identity_key_id_tag  6
#define vscr_Session_sender_ephemeral_key_tag    7
#define vscr_Session_receiver_identity_key_id_tag 8
#define vscr_Session_receiver_long_term_key_id_tag 9
#define vscr_Session_receiver_one_time_key_id_tag 10
#define vscr_Session_pqc_info_tag                11
#define vscr_Session_ratchet_tag                 12

/* Struct field encoding specification for nanopb */
#define vscr_ChainKey_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UINT32,   index,             1) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, key,               2)
#define vscr_ChainKey_CALLBACK NULL
#define vscr_ChainKey_DEFAULT NULL

#define vscr_MessageKey_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UINT32,   index,             1) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, key,               2)
#define vscr_MessageKey_CALLBACK NULL
#define vscr_MessageKey_DEFAULT NULL

#define vscr_SenderChain_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, private_key_first,   1) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, public_key_first,   2) \
X(a, POINTER,  OPTIONAL, BYTES,    private_key_second,   3) \
X(a, POINTER,  OPTIONAL, BYTES,    public_key_second,   4) \
X(a, POINTER,  OPTIONAL, BYTES,    encapsulated_key,   5) \
X(a, STATIC,   REQUIRED, MESSAGE,  chain_key,         6)
#define vscr_SenderChain_CALLBACK NULL
#define vscr_SenderChain_DEFAULT NULL
#define vscr_SenderChain_chain_key_MSGTYPE vscr_ChainKey

#define vscr_ReceiverChain_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, public_key_id,     1) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, public_key_first,   2) \
X(a, POINTER,  OPTIONAL, BYTES,    public_key_second,   3) \
X(a, STATIC,   REQUIRED, MESSAGE,  chain_key,         4)
#define vscr_ReceiverChain_CALLBACK NULL
#define vscr_ReceiverChain_DEFAULT NULL
#define vscr_ReceiverChain_chain_key_MSGTYPE vscr_ChainKey

#define vscr_SkippedMessageKey_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, public_key_id,     1) \
X(a, POINTER,  REPEATED, MESSAGE,  message_keys,      2)
#define vscr_SkippedMessageKey_CALLBACK NULL
#define vscr_SkippedMessageKey_DEFAULT NULL
#define vscr_SkippedMessageKey_message_keys_MSGTYPE vscr_MessageKey

#define vscr_SkippedMessages_FIELDLIST(X, a) \
X(a, STATIC,   REPEATED, MESSAGE,  keys,              1)
#define vscr_SkippedMessages_CALLBACK NULL
#define vscr_SkippedMessages_DEFAULT NULL
#define vscr_SkippedMessages_keys_MSGTYPE vscr_SkippedMessageKey

#define vscr_Ratchet_FIELDLIST(X, a) \
X(a, STATIC,   OPTIONAL, MESSAGE,  sender_chain,      1) \
X(a, STATIC,   REQUIRED, UINT32,   prev_sender_chain_count,   2) \
X(a, STATIC,   OPTIONAL, MESSAGE,  receiver_chain,    3) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, root_key,          4) \
X(a, STATIC,   REQUIRED, MESSAGE,  skipped_messages,   5) \
X(a, STATIC,   REQUIRED, BOOL,     enable_post_quantum,   6)
#define vscr_Ratchet_CALLBACK NULL
#define vscr_Ratchet_DEFAULT NULL
#define vscr_Ratchet_sender_chain_MSGTYPE vscr_SenderChain
#define vscr_Ratchet_receiver_chain_MSGTYPE vscr_ReceiverChain
#define vscr_Ratchet_skipped_messages_MSGTYPE vscr_SkippedMessages

#define vscr_SessionPqcInfo_FIELDLIST(X, a) \
X(a, POINTER,  REQUIRED, BYTES,    encapsulated_key1,   1) \
X(a, POINTER,  REQUIRED, BYTES,    encapsulated_key2,   2) \
X(a, POINTER,  OPTIONAL, BYTES,    encapsulated_key3,   3) \
X(a, POINTER,  REQUIRED, BYTES,    decapsulated_keys_signature,   4)
#define vscr_SessionPqcInfo_CALLBACK NULL
#define vscr_SessionPqcInfo_DEFAULT NULL

#define vscr_Session_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UINT32,   version,           1) \
X(a, STATIC,   REQUIRED, BOOL,     received_first_response,   2) \
X(a, STATIC,   REQUIRED, BOOL,     is_initiator,      3) \
X(a, STATIC,   REQUIRED, BOOL,     enable_post_quantum,   4) \
X(a, STATIC,   REQUIRED, BOOL,     receiver_has_one_time_public_key,   5) \
X(a, STATIC,   OPTIONAL, FIXED_LENGTH_BYTES, sender_identity_key_id,   6) \
X(a, STATIC,   OPTIONAL, FIXED_LENGTH_BYTES, sender_ephemeral_key,   7) \
X(a, STATIC,   OPTIONAL, FIXED_LENGTH_BYTES, receiver_identity_key_id,   8) \
X(a, STATIC,   OPTIONAL, FIXED_LENGTH_BYTES, receiver_long_term_key_id,   9) \
X(a, STATIC,   OPTIONAL, FIXED_LENGTH_BYTES, receiver_one_time_key_id,  10) \
X(a, STATIC,   OPTIONAL, MESSAGE,  pqc_info,         11) \
X(a, STATIC,   REQUIRED, MESSAGE,  ratchet,          12)
#define vscr_Session_CALLBACK NULL
#define vscr_Session_DEFAULT NULL
#define vscr_Session_pqc_info_MSGTYPE vscr_SessionPqcInfo
#define vscr_Session_ratchet_MSGTYPE vscr_Ratchet

#define vscr_ParticipantEpoch_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UINT32,   epoch,             1) \
X(a, STATIC,   REQUIRED, BOOL,     is_empty,          2) \
X(a, STATIC,   OPTIONAL, MESSAGE,  chain_key,         3) \
X(a, POINTER,  REPEATED, MESSAGE,  message_keys,      4)
#define vscr_ParticipantEpoch_CALLBACK NULL
#define vscr_ParticipantEpoch_DEFAULT NULL
#define vscr_ParticipantEpoch_chain_key_MSGTYPE vscr_ChainKey
#define vscr_ParticipantEpoch_message_keys_MSGTYPE vscr_MessageKey

#define vscr_ParticipantData_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, id,                1) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, pub_key,           2) \
X(a, STATIC,   FIXARRAY, MESSAGE,  epochs,            3)
#define vscr_ParticipantData_CALLBACK NULL
#define vscr_ParticipantData_DEFAULT NULL
#define vscr_ParticipantData_epochs_MSGTYPE vscr_ParticipantEpoch

#define vscr_GroupSession_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UINT32,   version,           1) \
X(a, STATIC,   REQUIRED, UINT32,   my_epoch,          2) \
X(a, STATIC,   REQUIRED, MESSAGE,  my_chain_key,      3) \
X(a, STATIC,   FIXARRAY, UINT32,   messages_count,    4) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, session_id,        5) \
X(a, STATIC,   REQUIRED, FIXED_LENGTH_BYTES, my_id,             6) \
X(a, POINTER,  REPEATED, MESSAGE,  participants,      7)
#define vscr_GroupSession_CALLBACK NULL
#define vscr_GroupSession_DEFAULT NULL
#define vscr_GroupSession_my_chain_key_MSGTYPE vscr_ChainKey
#define vscr_GroupSession_participants_MSGTYPE vscr_ParticipantData

extern const pb_msgdesc_t vscr_ChainKey_msg;
extern const pb_msgdesc_t vscr_MessageKey_msg;
extern const pb_msgdesc_t vscr_SenderChain_msg;
extern const pb_msgdesc_t vscr_ReceiverChain_msg;
extern const pb_msgdesc_t vscr_SkippedMessageKey_msg;
extern const pb_msgdesc_t vscr_SkippedMessages_msg;
extern const pb_msgdesc_t vscr_Ratchet_msg;
extern const pb_msgdesc_t vscr_SessionPqcInfo_msg;
extern const pb_msgdesc_t vscr_Session_msg;
extern const pb_msgdesc_t vscr_ParticipantEpoch_msg;
extern const pb_msgdesc_t vscr_ParticipantData_msg;
extern const pb_msgdesc_t vscr_GroupSession_msg;

/* Defines for backwards compatibility with code written before nanopb-0.4.0 */
#define vscr_ChainKey_fields &vscr_ChainKey_msg
#define vscr_MessageKey_fields &vscr_MessageKey_msg
#define vscr_SenderChain_fields &vscr_SenderChain_msg
#define vscr_ReceiverChain_fields &vscr_ReceiverChain_msg
#define vscr_SkippedMessageKey_fields &vscr_SkippedMessageKey_msg
#define vscr_SkippedMessages_fields &vscr_SkippedMessages_msg
#define vscr_Ratchet_fields &vscr_Ratchet_msg
#define vscr_SessionPqcInfo_fields &vscr_SessionPqcInfo_msg
#define vscr_Session_fields &vscr_Session_msg
#define vscr_ParticipantEpoch_fields &vscr_ParticipantEpoch_msg
#define vscr_ParticipantData_fields &vscr_ParticipantData_msg
#define vscr_GroupSession_fields &vscr_GroupSession_msg

/* Maximum encoded size of messages (where known) */
/* vscr_SenderChain_size depends on runtime parameters */
/* vscr_ReceiverChain_size depends on runtime parameters */
/* vscr_SkippedMessageKey_size depends on runtime parameters */
/* vscr_SkippedMessages_size depends on runtime parameters */
/* vscr_Ratchet_size depends on runtime parameters */
/* vscr_SessionPqcInfo_size depends on runtime parameters */
/* vscr_Session_size depends on runtime parameters */
/* vscr_ParticipantEpoch_size depends on runtime parameters */
/* vscr_ParticipantData_size depends on runtime parameters */
/* vscr_GroupSession_size depends on runtime parameters */
#define vscr_ChainKey_size                       40
#define vscr_MessageKey_size                     40

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
